#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	assert(argc >= 6);
	int q = atoi(argv[1]);
	int sz = atoi(argv[2]);
	int maxd = atoi(argv[3]);
	int bal = atoi(argv[4]);
	double part_questions = atof(argv[5]);

	vector<vector<pair<int, char>>> graph(1);
	vector<pair<int, char>> parent;
	parent.push_back({-1, 0});
	vector<int> good = {0};
	vector<int> depth = {0};

	for (int i = 0; i < sz; ++i) {
		int par;
		char c;
		while (true) {
			par = good[rnd.next(0, szof(good) - 1)];
			c = rnd.next('a', 'z');
			bool ok = true;
			for (auto& p : graph[par]) {
				if (p.ss == c) {
					ok = false;
					break;
				}
			}
			if (ok) {
				break;
			}
		}
		graph[par].push_back({szof(graph), c});
		graph.push_back({});
		depth.push_back(depth[par] + 1);
		parent.push_back({par, c});
		if (depth[i + 1] < maxd) {
			good.push_back(i + 1);
		}
	}

	cout << q << "\n";
	
	int bpv = 1;
	while (bpv < sz) {
		bpv *= 2;
	}
	vector<int> rsq(bpv * 2);

	function<void(int, int)> rsq_set = [&](int pos, int val) {
		pos += bpv;
		rsq[pos] = val;
		pos /= 2;
		while (pos) {
			rsq[pos] = rsq[pos * 2] + rsq[pos * 2 + 1];
			pos /= 2;
		}
	};

	function<int(int, int, int, int, int)> rsq_getsum = [&](int v, int vl, int vr, int l, int r) {
		if (vr <= l || r <= vl) {
			return 0;
		}
		if (l <= vl && vr <= r) {
			return rsq[v];
		}
		int vm = (vl + vr) / 2;
		return rsq_getsum(v * 2, vl, vm, l, r) + rsq_getsum(v * 2 + 1, vm, vr, l, r);
	};

	vector<int> reqs_number(sz);
	int cnt = 0;

	for (int i = 0; i < q; ++i) {
		int amount = rsq_getsum(1, 0, bpv, 0, bpv);
		int type;
		if (i < bal) {
			type = 0;
		} else if (amount && rnd.next() < part_questions) {
			// cerr << part_questions << endl;
			type = 2;
		} else {
			while (true) {
				if (rnd.next() < exp((bal - amount) / (double) sz) / (exp((bal - amount) / (double) sz) + exp((amount - bal) / (double) sz))) {
					type = 0;
				} else {
					type = 1;
				}

				if (!amount && type != 0) {
					continue;
				}
				if (amount == sz && type == 0) {
					continue;
				}
				break;
			}
		}

		if (type == 0) {
			int pos = rnd.next(0, sz - amount - 1);
			int l = -1, r = sz;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (mid - rsq_getsum(1, 0, bpv, 0, mid) <= pos) {
					l = mid;
				} else {
					r = mid;
				}
			}
			pos = l;
			// cerr << pos << endl;
			rsq_set(pos, 1);
			reqs_number[pos] = cnt++;
			string s;
			int cur = pos + 1;
			while (cur) {
				s += parent[cur].ss;
				cur = parent[cur].ff;
			}

			reverse(s.begin(), s.end());

			cout << "+ " << s << "\n";
		} else if (type == 1) {
			int pos = rnd.next(0, amount - 1);
			int l = -1, r = sz;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (rsq_getsum(1, 0, bpv, 0, mid) <= pos) {
					l = mid;
				} else {
					r = mid;
				}
			}
			pos = l;
			rsq_set(pos, 0);

			cout << "- " << reqs_number[pos] + 1 << "\n";
		} else {
			int pos = rnd.next(0, amount - 1);
			int l = -1, r = sz;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (rsq_getsum(1, 0, bpv, 0, mid) <= pos) {
					l = mid;
				} else {
					r = mid;
				}
			}
			pos = l;

			cout << "? " << reqs_number[pos] + 1 << "\n";
		}
	}

	return 0;
}