#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int q;
	cin >> q;
	vector<string> all, have;
	for (int i = 0; i < q; ++i) {
		char type;
		cin >> type;
		if (type == '+') {
			string s;
			cin >> s;
			all.push_back(s);
			have.push_back(s);
		} else if (type == '-') {
			int ind;
			cin >> ind;
			--ind;
			have.erase(find(have.begin(), have.end(), all[ind]));
		} else {
			int ind;
			cin >> ind;
			--ind;
			int ans = 0;

			for (int i = 0; i < szof(all[ind]); ) {
				bool letter = false;
				int shift = INF;
				for (int j = 0; j < szof(have); ++j) {
					if (have[j].substr(0, i) == all[ind].substr(0, i)) {
						if (szof(have[j]) == i || have[j][i] != all[ind][i]) {
							letter = true;
							break;
						}
						int pos = i;
						while (pos < szof(have[j]) && pos < szof(all[ind]) && have[j][pos] == all[ind][pos]) {
							++pos;
						}
						shift = min(shift, pos);
					}
				}
				if (letter) {
					++ans;
					++i;
					continue;
				}
				i = shift;
				++ans;
			}

			cout << ans << "\n";
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
