#ifdef LOCAL
#  define _GLIBCXX_DEBUG
#else
#  define cerr __get_ce
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
mt19937 tw(9450189);
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

struct node {
	vector<int> go, on;
	int children;
	bool ends_here;
	node() : go(26, -1), on(26), children(0), ends_here(false) {}
};

vector<node> trie;

void solve() {
	trie.push_back(node());
	int q;
	cin >> q;
	vector<string> all;
	for (int i = 0; i < q; ++i) {
		char type;
		cin >> type;
		if (type == '+') {
			string s;
			cin >> s;
			all.push_back(s);
			int cur = 0;
			for (char c : s) {
				if (trie[cur].go[c - 'a'] == -1) {
					trie[cur].go[c - 'a'] = szof(trie);
					trie.push_back(node());
				}
				trie[cur].on[c - 'a']++;
				if (trie[cur].on[c - 'a'] == 1) {
					trie[cur].children++;
				}
				cur = trie[cur].go[c - 'a'];
			}
			trie[cur].ends_here = true;
		} else if (type == '-') {
			int ind;
			cin >> ind;
			--ind;
			int cur = 0;
			for (char c : all[ind]) {
				trie[cur].on[c - 'a']--;
				if (trie[cur].on[c - 'a'] == 0) {
					trie[cur].children--;
				}
				cur = trie[cur].go[c - 'a'];
			}
			trie[cur].ends_here = false;
		} else {
			int ind;
			cin >> ind;
			--ind;
			int ans = 0;
			bool fl = false;
			int cur = 0;
			for (char c : all[ind]) {
				if (trie[cur].children > 1 || trie[cur].ends_here) {
					fl = false;
					++ans;
				} else if (!fl) {
					fl = true;
					++ans;
				}
				cur = trie[cur].go[c - 'a'];
			}

			cout << ans << "\n";
		}
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
