#include <bits/stdc++.h>

std::vector<int> bad_bits(int a, int b) {
    std::vector<int> bits;
    for (int i = 0; i < 30; i++) {
        int abit = (a & (1 << i));
        int bbit = (b & (1 << i));
        if (abit == 0 && bbit > 0) {
            bits.push_back(i);
        }
    }
    return bits;
}

bool is_ok(int a, int b) {
    for (int i = 0; i < 30; i++) {
        int abit = (a & (1 << i));
        int bbit = (b & (1 << i));
        if (abit > 0 && bbit == 0) {
            return false;
        }
    }
    return true;
}

int main() {
    int n, a, b;
    std::cin >> n >> a >> b;
    std::vector<int> x(n);
    for (int i = 0; i < n; i++) {
        std::cin >> x[i];
    }
    if (!is_ok(a, b)) {
        printf("-1\n");
        return 0;
    }
    std::vector<int> answer;
    for (int it = 0; it < 100; it++) {
        if (a == b) {
            printf("%d\n", (int)answer.size());
            for (int e : answer) {
                printf("%d ", e + 1);
            }
            printf("\n");
            return 0;
        }
        std::vector<int> bs = bad_bits(a, b);
        bool found = false;
        for (int i = 0; i < n; i++) {
            if (is_ok(a | x[i], b) && bad_bits(a | x[i], b).size() < bs.size()) {
                a |= x[i];
                answer.push_back(i);
                found = true;
                break;
            }
        }
        if (!found) {
            printf("-1\n");
            return 0;
        }
    }
    printf("-1\n");
    return 0;
}
